sub AT_Read {
  my(@at);
  if(-e $AT_FILENAME) {
    open(AT_FILE, $AT_FILENAME) ||
      HTMLError("Cant open $AT_FILENAME!");
    while(<AT_FILE>) {
      chomp;
      next if($_ eq "");
      my($active, $pattern, $section, $start, $stop, $episode, $prio, $lft, $channel) = split(/\:/, $_);
      push(@at, {
				active   => $active,
				pattern  => $pattern,
				section  => $section,
				start    => $start,
				stop     => $stop,
				episode  => $episode,
				prio     => $prio,
				lft      => $lft,
				channel  => $channel
      });
    }
    close(AT_FILE);
  }
  return(@at);
}

sub AT_Write {
  my @at = @_;
  open(AT_FILE, ">" . $AT_FILENAME) || 
    HTMLError("Cant open $AT_FILENAME!");
  for(@at) {
    my $temp;
    for my $item (qw(active pattern section start stop episode prio lft channel)) {
      if(length($temp) == 0) {
				$temp = $_->{$item};
      } else {
				$temp .= ":" . $_->{$item};
      }
    }
    print AT_FILE $temp, "\n";
  }
  close(AT_FILE);
}

sub AutoTimer {
  return if(!$CONFIG{AT_FUNC});
  Log(LOG_AT, "Auto Timer: Scanning for events...");
  my($search, $start, $stop) = @_;
 
  my @at = AT_Read();
  
  for my $sender (keys(%EPG)) {
    for my $event (@{$EPG{$sender}}) {
      for my $at (@at) {
				if(!$at->{active}) {
					next;
				}

				if($at->{channel}) {
					if($at->{channel} != $event->{vdr_id}) {
						next;
					}
				}

				#
				my @section;
				if($at->{section} & 1) {
					push(@section, "title");
				} 
				if($at->{section} & 2) {
					push(@section, "subtitle");
				} 
				if($at->{section} & 4) {
					push(@section, "summary");
				}
				
				#
				next if(!$at->{pattern});
				
				#
				my $fs = 0;
				for my $section (@section) {
					my $fp = 1;
					for my $pattern (split(/ +/, $at->{pattern})) {
						if($event->{$section} !~ /$pattern/i) {
							$fp = 0;
						}
					}
					next if(!$fp);
					$fs = 1;
				}	
				next if(!$fs);
				
				#
				if($at->{start}) {
					if(((my_strftime("%H%M", $event->{start})) < $at->{start})) {
						if(my_strftime("%H%M", $at->{stop}) > my_strftime("%H%M", $at->{start})) {
							next;
						}
					}
				}

				#
				if($at->{stop}) {
					($at->{stop} < $at->{start}) ? $at->{stop} += 2400 : undef;
					if((my_strftime("%H%M", $event->{stop})) > $at->{stop}) {
						next;
					}
				}
				
				#print($event->{title} . " " . (strftime("%H:%M", localtime($event->{time}))) . " " . (strftime("%H:%M", localtime($event->{time} + $event->{duration}))) . "\n");
				
				if($at->{episode}) {
					ProgTimer(1, $event->{vdr_id}, $event->{start}, $event->{stop}, 
						$event->{title} . "~" . $event->{subtitle}, "", $at->{prio}, $at->{lft});
				} else {
					ProgTimer(1, $event->{vdr_id}, $event->{start}, $event->{stop}, 
						$event->{title}, "", $at->{prio}, $at->{lft});
				}
      }
    }
  }
  Log(LOG_AT, "Auto Timer: Done.");
}


1;
